﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Personagem : MonoBehaviour {
	float Vx; 	
	float Vy;	
	float VelocidadeHorizontal;
	float VelocidadeVertical;
	float VelocidadePular;
	float DirecaoHorizontal; 
	float DirecaoVertical; 
	Rigidbody2D CorpoRigido; 
	PolygonCollider2D Colisor; 
	SpriteRenderer PersonagemSpriteRender;
	Animator AnimatorPersonagem;
	int ContadorPulos;
	bool EstaAtacando;
	PolygonCollider2D CirculoAtaqueEsquerdo;
	PolygonCollider2D CirculoAtaqueDireito;

	//"void Start ()" Executado na inicialização do jogo utilizado para iniciar variáveis e parametros 
	void Start () {
		Vx = 0;	Vy = 0;	DirecaoVertical = 0;	
		DirecaoHorizontal = 0;VelocidadeHorizontal = 5;	
		VelocidadeVertical = 5;	VelocidadePular	= 5;		
		ContadorPulos = 0; EstaAtacando = false;
		CorpoRigido = GetComponent<Rigidbody2D> ();		
		Colisor = GetComponent<PolygonCollider2D> (); 	
		AnimatorPersonagem = GetComponent<Animator>();
		PersonagemSpriteRender = GetComponent<SpriteRenderer> ();
		//recupera o PolygonCollider2D das areas de ataque
		CirculoAtaqueEsquerdo=GameObject.FindGameObjectWithTag ("areaAtaqueEsquerda").GetComponent<PolygonCollider2D>();
		CirculoAtaqueDireito=GameObject.FindGameObjectWithTag ("areaAtaqueDireita").GetComponent<PolygonCollider2D>();
		CorpoRigido.freezeRotation = true;	
		CorpoRigido.gravityScale = 1;					
	}
		
	void Update () {
		MovimentoHorizontal();
		PuloDuplo ();
		Atacar();
	}
	void Atacar(){
		if (Input.GetKey (KeyCode.LeftControl)) {
			EstaAtacando = true;
			AnimatorPersonagem.SetBool ("andando", false);
			AnimatorPersonagem.SetBool ("estaAtacando", true);
		}
		//Entra no if após a execução da animação atacando.
		if (AnimatorPersonagem.GetCurrentAnimatorStateInfo (0).IsName ("atacando")) {
			AnimatorPersonagem.SetBool ("estaAtacando", false);
			EstaAtacando = false;
		}
	}

	void PuloDuplo(){
		//verdadeiro(true) se o botão de Jump foi pressionado caso contrário igual a false
		bool apertou = Input.GetButtonDown ("Jump");
		// esse bloco só é executado se for apertado o botão de Jump
		// e se o personagem ContadorPulos < 2
		if (apertou == true && ContadorPulos < 2 ) {
			AnimatorPersonagem.SetBool ("parado", false);
			AnimatorPersonagem.SetBool ("estaPulando", true);

			//AnimatorPersonagem.SetBool ("estaAnando", false);
			ContadorPulos = ContadorPulos+1;
			Vx = CorpoRigido.velocity.x;
			Vy = VelocidadePular;
			Vector2 pulo = new Vector2 (Vx, Vy);
			CorpoRigido.velocity = pulo;
		}
	}

	void MovimentoHorizontal(){
		DirecaoHorizontal = Input.GetAxis ("Horizontal");
		if (DirecaoHorizontal > 0) {
			PersonagemSpriteRender.flipX = false;
			CirculoAtaqueEsquerdo.enabled = false;
			CirculoAtaqueDireito.enabled = true;
		} 
		if (DirecaoHorizontal < 0) {
			PersonagemSpriteRender.flipX = true;
			CirculoAtaqueEsquerdo.enabled = true;
			CirculoAtaqueDireito.enabled = false;
		}
		if (DirecaoHorizontal != 0) {
			AnimatorPersonagem.SetBool ("andando", true);
			AnimatorPersonagem.SetBool ("estaAtacando", false);
		} else {
			AnimatorPersonagem.SetBool ("andando", false);
		}
		Vx = VelocidadeHorizontal * DirecaoHorizontal;
		Vy = CorpoRigido.velocity.y;
		Vector2 andar = new Vector2 (Vx, Vy);
		CorpoRigido.velocity = andar;
	}


	//(Collision2D objetoTocado) é executado sempre que um colisor toca em outro colisor
	//a variável objetoTocado possui dados do objeto tocado.
	void OnCollisionEnter2D(Collision2D objetoTocado){
		AnimatorPersonagem.SetBool ("estaPulando", false);
		ContadorPulos = 0;
		string tagTocada = objetoTocado.gameObject.tag; 
		//AnimatorPersonagem.SetBool ("estaPulando", false);

	}

	void OnTriggerStay2D(Collider2D objetoTocado){
		string tagTocada = objetoTocado.gameObject.tag; 
		if (tagTocada == "inimigo" && EstaAtacando == true) {
			print ("tocou: " + tagTocada);
			byte vermelho = 100;
			byte verde = 0;
			byte azul = 0;
			byte opacidade = 25;
			//recupera o material do inimigo
			Material material = objetoTocado.GetComponent<Renderer>().material;
			//muda a cor do inimigo
			material.color = new Color(vermelho, verde, azul,opacidade);
			//destroi o inimigo
			Destroy (objetoTocado.gameObject,0.2f);
		}
	}

}