﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Personagem2 : MonoBehaviour {
	float Vx; 	//velocidade em x
	float Vy;	//velocidade em y
	float VelocidadeHorizontal;
	float VelocidadeVertical;
	float VelocidadePular;
	float DirecaoHorizontal; //variavel que armazena a direção: para esquerda, para a direita ou parado
	float DirecaoVertical; //variavel que armazena a direção: para cima, para a baixo ou parado
	Rigidbody2D CorpoRigido; //corpo rígido do elemento onde o script foi inserido.
	PolygonCollider2D Colisor; // colisor do elemento onde o script foi inserido.
	SpriteRenderer PersonagemSpriteRender;
	Animator AnimatorPersonagem;
	int ContadorPulos;
	bool EstaAtacando;
	bool EstaNaAreaAtaque;
	//"void Start ()" Executado na inicialização do jogo utilizado para iniciar variáveis e parametros 
	void Start () {
		Vx = 0;		//inicia a velocidade em x
		Vy = 0;		//inicia a velocidade em y
		DirecaoVertical = 0;		// inicia a direção vertical("andar para cima e para baixo")
		DirecaoHorizontal = 0;		// inicia a direção horizontal(andar)
		VelocidadeHorizontal = 5;	//incia a velocidade de andar na horizontal(direita e esquerda)
		VelocidadeVertical = 5;		//inicia a velocidade de andar na vertical	(para cima e para baixo)
		VelocidadePular	= 5;		//inicia a velocidade de pular
		ContadorPulos = 0;
		EstaAtacando = false;
		EstaNaAreaAtaque = false;
		CorpoRigido = GetComponent<Rigidbody2D> ();		//recupera o corpo rigido inserido no elemento que possui o script(corpo rígido do personagem)
		Colisor = GetComponent<PolygonCollider2D> (); 	//recupera o colisor inserido no elemento que possui o script(colisor do personagem)	
		AnimatorPersonagem = GetComponent<Animator>();
		PersonagemSpriteRender = GetComponent<SpriteRenderer> ();
		CorpoRigido.freezeRotation = true;				//impede que rotacione no eixo.
		//inicia a escala de gravidade com 1 - caso utilize MovimentoVertical()  ao invés Pular() gravityScale = 1 deve ser igual 0
		CorpoRigido.gravityScale = 1;					
	}

	//"void Update ()" Executado uma vez por frame. 
	void Update () {
		MovimentoHorizontal();
		//PuloSimples();
		PuloDuplo ();
		//MovimentoVertical ();
		Atacar();
	}
	void Atacar(){
		if (Input.GetKey (KeyCode.LeftControl)) {
			EstaAtacando = true;
			AnimatorPersonagem.SetBool ("estaAtacando", true);

			//AnimatorPersonagem.SetBool ("estaAtacando", false);

		}
		if (AnimatorPersonagem.GetCurrentAnimatorStateInfo (0).IsName ("atacando")) {
			AnimatorPersonagem.SetBool ("estaAtacando", false);
			EstaAtacando = false;
		}
	}
	void PuloSimples(){
		//verdadeiro(true) se o botão de Jump foi pressionado caso contrário igual a false
		bool apertou = Input.GetButtonDown ("Jump");

		//verdadeiro(true) se o personagem estiver tocando outro collider
		bool tocou = Colisor.IsTouchingLayers ();

		if (apertou == true && tocou == true) {
			// esse bloco só é executado se for apertado o botão de Jump
			// e se o personagem estiver tocando em alguma coisa com colidder
			Vx = CorpoRigido.velocity.x;
			Vy = VelocidadePular;
			Vector2 pulo = new Vector2 (Vx, Vy);
			CorpoRigido.velocity = pulo;
		}
	}
	void PuloDuplo(){
		//verdadeiro(true) se o botão de Jump foi pressionado caso contrário igual a false
		bool apertou = Input.GetButtonDown ("Jump");
		// esse bloco só é executado se for apertado o botão de Jump
		// e se o personagem ContadorPulos < 2
		if (apertou == true && ContadorPulos < 2 ) {
			ContadorPulos = ContadorPulos+1;
			Vx = CorpoRigido.velocity.x;
			Vy = VelocidadePular;
			Vector2 pulo = new Vector2 (Vx, Vy);
			CorpoRigido.velocity = pulo;
		}
	}

	void MovimentoHorizontal(){
		//DirecaoHorizontal Recebe até 1 quando precionado o botão para direita e até -1 para esquerda. Quando parado Recebe 0.
		DirecaoHorizontal = Input.GetAxis ("Horizontal");
		if (DirecaoHorizontal > 0) {

			PolygonCollider2D circuloAtaqueDireito = GameObject.FindGameObjectWithTag ("areaAtaque").GetComponent<PolygonCollider2D>();
			circuloAtaqueDireito.enabled = false;

			PersonagemSpriteRender.flipX = false;
		
			GameObject objetoAreaAtaque = GameObject.FindGameObjectWithTag ("areaAtaque");
			Transform tranformObjetoTocado = objetoAreaAtaque.GetComponent<Transform> ();
			tranformObjetoTocado.position = new Vector2 (1.456f + transform.position.x, transform.position.y);
			//print (DirecaoHorizontal);


		

		} 
		if (DirecaoHorizontal < 0) {
			PersonagemSpriteRender.flipX = true;
			GameObject objetoAreaAtaque = GameObject.FindGameObjectWithTag ("areaAtaque");
			Transform tranformObjetoTocado = objetoAreaAtaque.GetComponent<Transform> ();
	
			tranformObjetoTocado.position = new Vector2 (-1.456f + transform.position.x, transform.position.y);
			//print (DirecaoHorizontal);
		}
		// Gera uma nova velocidade em x
		Vx = VelocidadeHorizontal * DirecaoHorizontal;
		//Recupera a velocidade em y que o personagem já possui
		Vy = CorpoRigido.velocity.y;
		//Cria um vetor de velocidade com os valores da velocidade em x e da velocidade em y (vx e vy)
		Vector2 andar = new Vector2 (Vx, Vy);
		// O vetor de velocidade é adicionado a velocidade do corpo rígido do personagem
		CorpoRigido.velocity = andar;
	
	}

	void MovimentoVertical(){
		//DirecaoVertical Recebe até 1 quando precionado o botão para cima e até -1 para baixo. Quando parado Recebe 0.
		DirecaoVertical = Input.GetAxis ("Vertical");
		Vx = CorpoRigido.velocity.x; //Recupera a velocidade em x que o personagem já possui em seu corpo rígido
		// Gera uma nova velocidade em y
		Vy = VelocidadeVertical*DirecaoVertical;

		Vector2 vetorMovimento = new Vector2 (Vx, Vy);  //Cria um vetor de velocidade com os valores da velocidade em x e da velocidade em y (vx e vy)
		CorpoRigido.velocity = vetorMovimento;			// O vetor de velocidade é adicionado a velocidade do corpo rígido do personagem

	}

	//(Collision2D objetoTocado) é executado sempre que um colisor toca em outro colisor
	//a variável objetoTocado possui dados do objeto tocado.
	void OnCollisionEnter2D(Collision2D objetoTocado){
		ContadorPulos = 0;
		string tagTocada = objetoTocado.gameObject.tag; 

	

	}
	void OnTriggerStay2D(Collider2D objetoTocado)
	{
		string tagTocada = objetoTocado.gameObject.tag; 

		if (tagTocada == "inimigo") {

		
			if (EstaAtacando == true) {
				print ("tocou: " + tagTocada);
				Destroy (objetoTocado.gameObject);
			}

		}

	}
}